#ifndef COUPLINGS_h
#define COUPLINGS_h
/**************************************************/
/*  class to evaluate the user defined couplings  */
/**************************************************/
//----------------
#include "Moses.h"
//----------------
#include "parameters.h"
#include "mosesParticle.h"
#include "gellMannMatrices.h"

using namespace std;

namespace Moses1 {

class couplings {
	public:
		couplings();
		virtual ~couplings();
		// to return the couplings of a fermion with helicity lambda=+1/2 to Z0/gamma gauge bosons
		virtual double getCouplings(double helicity,
					pdtParticle &propagator, customParticle &fermion,
					physicalParameters &physPrm);
		
		virtual double getCouplings(unsigned int nMode, double helicity,
					pdtParticle &propagator, customParticle &fermion,
					physicalParameters &physPrm);

		virtual dcomplex  getMassiveGlounSchannelCouplings(unsigned int Lambda_I,unsigned int nMode, double helicity1, double helicity2,
									  pdtParticle &propagator,  customParticle &fermion1,customParticle &fermion2,
									  physicalParameters &physPrm);
	private:
		gellMannMatrices gMatrix;
};

}
#endif
